/*
* FORTRAN wrappers for runtime data mapping PARTI primitives
*/
#include<stdio.h>
#include "parti.h"

/*===================================================================*/
remap_old_(color, cur_local_ind, cur_n_data,  sched, new_local_ind, newndata)
int *color;
int *cur_local_ind, *cur_n_data;
int *sched;
int *new_local_ind, *newndata;
{
   int index;
   SCHED *csched;

    int i, ndata;
  
    ndata = *cur_n_data;


   for(i=0; i<ndata; i++) {
      cur_local_ind[i]--;
   }

  remap_old(color, cur_local_ind, ndata, &csched, new_local_ind, newndata);

    *sched =  register_schedule(csched);

   for(i=0; i<ndata; i++) {
      cur_local_ind[i]++;
   }
   for(i=0; i<*newndata; i++) {
      new_local_ind[i]++;
   }
}
/*===================================================================*/

remap_(table, cur_local_ind,  sched, new_local_ind, newndata)
int *table;
int *cur_local_ind;
int *sched;
int *new_local_ind, *newndata;
{
   int index;
   SCHED *csched;
   TTABLE *tabptr;

    int i, ndata;
  
   tabptr = (TTABLE *) get_table_ptr(*table);
   ndata  = trans_table_size( tabptr );


   for(i=0; i<ndata; i++) {
      cur_local_ind[i]--;
   }


   remap(tabptr, cur_local_ind,  &csched, new_local_ind, newndata);

   *sched =  register_schedule(csched);

   for(i=0; i<ndata; i++) {
      cur_local_ind[i]++;
   }
   for(i=0; i<*newndata; i++) {
      new_local_ind[i]++;
   }
}
/*===================================================================*/

#define TRUE 1
#define FALSE 0

/***********************************************************/
/* IN:                                                     */
/* ttable : translation table for lhs array indices        */
/* color : array returned by partitioner describing partition */
/* my_size : size of lhs indices                           */
/* my_loop_size: the  size of loop iteration               */
/* ref_per_iter: no of different refs considered per iter  */
/* OUT:                                                    */
/* loop_color : array that describes the loop partition    */
/***********************************************************/

dref_rig_(tabindex, ind_referred, my_loop_size, ref_per_iter, ripa)
int *tabindex;
int *ref_per_iter, *my_loop_size;
int *ind_referred;
int *ripa;
{

    int i, ndata;
    int loop_size, n_ref;
    TTABLE *ttable;
    FILE *fp;
     char fname[20];


     ttable = (TTABLE *)get_table_ptr(*tabindex);

     loop_size = *my_loop_size;
     n_ref     = *ref_per_iter;

     for(i=0; i<loop_size*n_ref; i++) {
        ind_referred[i]--;
     }

     dref_rig(ttable, ind_referred, loop_size, n_ref, ripa);

     for(i=0; i<loop_size*n_ref; i++) {
        ind_referred[i]++;
     }
 }

/*===================================================================*/
iteration_partitioner_old_(ripa,  my_loop_size, ref_per_iter, edge_color)
int *ripa, *ref_per_iter, *my_loop_size;
int *edge_color;
{
  iteration_partitioner_old(ripa, *my_loop_size, *ref_per_iter,  edge_color);

}
/*===================================================================*/

iteration_partitioner_(ripa,  my_loop_size, ref_per_iter, itable)
int *ripa, *ref_per_iter, *my_loop_size;
int *itable;
{
  TTABLE *table;
  iteration_partitioner(ripa, *my_loop_size, *ref_per_iter,  &table);
  
  *itable =  register_table(table);

}
/*===================================================================*/


